from __future__ import annotations

from collections.abc import Mapping
from typing import TYPE_CHECKING, Any, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

if TYPE_CHECKING:
    from ..models.stack_update_body_stack_diff import StackUpdateBodyStackDiff


T = TypeVar("T", bound="StackUpdateBody")


@_attrs_define
class StackUpdateBody:
    """
    Attributes:
        stack_id (str): MongoDB ObjectId
        stack_diff (StackUpdateBodyStackDiff): Fields to update
    """

    stack_id: str
    stack_diff: StackUpdateBodyStackDiff
    additional_properties: dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> dict[str, Any]:
        stack_id = self.stack_id

        stack_diff = self.stack_diff.to_dict()

        field_dict: dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "stackId": stack_id,
                "stackDiff": stack_diff,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: type[T], src_dict: Mapping[str, Any]) -> T:
        from ..models.stack_update_body_stack_diff import StackUpdateBodyStackDiff

        d = dict(src_dict)
        stack_id = d.pop("stackId")

        stack_diff = StackUpdateBodyStackDiff.from_dict(d.pop("stackDiff"))

        stack_update_body = cls(
            stack_id=stack_id,
            stack_diff=stack_diff,
        )

        stack_update_body.additional_properties = d
        return stack_update_body

    @property
    def additional_keys(self) -> list[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
